=== debian/changelog ===
sysrepo (2.0.53-6.1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 15:59:28 +1100

sysrepo (2.0.53-6.1build1) noble; urgency=medium

  * No-change rebuild against libyang2 t64.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 17 Mar 2024 18:20:35 +0100

sysrepo (2.0.53-6.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062957

 -- Benjamin Drung <bdrung@debian.org>  Thu, 29 Feb 2024 17:57:10 +0000

sysrepo (2.0.53-6) unstable; urgency=medium

  * Don't move the /etc/sysrepo if it doesn't exist

 -- Ondřej Surý <ondrej@debian.org>  Fri, 26 Nov 2021 11:32:54 +0100

sysrepo (2.0.53-5) unstable; urgency=medium

  * Add upstream patch to fix crash in sysrepoctl

 -- Ondřej Surý <ondrej@debian.org>  Thu, 25 Nov 2021 21:17:43 +0100

sysrepo (2.0.53-4) unstable; urgency=medium

  * Add preinst and postinst scripts to cleanup /etc/sysrepo on install,
    upgrade and purge

 -- Ondřej Surý <ondrej@debian.org>  Thu, 25 Nov 2021 16:01:18 +0100

sysrepo (2.0.53-3) unstable; urgency=medium

  * Add proper Multi-Arch headers
  * Switch the libsysrepo-dev dependency from libyang-dev to libyang2-dev

 -- Ondřej Surý <ondrej@debian.org>  Thu, 25 Nov 2021 10:08:17 +0100

sysrepo (2.0.53-2) unstable; urgency=medium

  * Drop libpcre2-dev from Build-Depends (it's now correctly listed in
    libyang2-dev)

 -- Ondřej Surý <ondrej@debian.org>  Thu, 25 Nov 2021 09:56:05 +0100

sysrepo (2.0.53-1) unstable; urgency=medium

  * New upstream version 2.0.53
  * Bump the build-dependency to libyang2-dev
  * Drop the C++ packages, they were dropped by upstream
  * Install the extra file (header and man pages)
  * Bump the libsysrepo soname from 5 to 6
  * Update symbols file for 2.0.53 release
  * Add libpcre2-dev as temporary Build-Depends

 -- Ondřej Surý <ondrej@debian.org>  Sat, 13 Nov 2021 16:44:41 +0100
