=== debian/control ===
Source: sysrepo
Section: libs
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Ondřej Surý <ondrej@debian.org>
Priority: optional
Standards-Version: 4.5.1.0
Build-Depends: dpkg-dev (>= 1.22.5), cmake,
               debhelper-compat (= 12),
               doxygen,
               graphviz,
               libyang2-dev,
               pkg-config
Homepage: https://github.com/sysrepo/sysrepo

Package: sysrepo
Depends: libsysrepo6t64 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Section: admin
Architecture: any
Multi-Arch: foreign
Description: YANG-based configuration and operational state data store [tools]
 Applications can use sysrepo to store their configuration modeled by provided
 YANG model instead of using e.g. flat configuration files. Sysrepo will ensure
 data consistency of the data stored in the datastore and enforce data
 constraints defined by YANG model.
 .
 Sysrepo can be easily integrated with management agents such as NETCONF or
 RESTCONF servers, using the same client library API that applications use to
 access their configuration.
 .
 This package contains the tools to work with schemas and configuration.

Package: sysrepo-doc
Depends: ${misc:Depends}
Section: doc
Architecture: all
Multi-Arch: foreign
Description: YANG-based configuration and operational state data store [docs]
 Applications can use sysrepo to store their configuration modeled by provided
 YANG model instead of using e.g. flat configuration files. Sysrepo will ensure
 data consistency of the data stored in the datastore and enforce data
 constraints defined by YANG model.
 .
 Sysrepo can be easily integrated with management agents such as NETCONF or
 RESTCONF servers, using the same client library API that applications use to
 access their configuration.
 .
 This package contains the documentation.

Package: sysrepo-plugind
Depends: libsysrepo6t64 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Section: admin
Architecture: any
Multi-Arch: foreign
Description: YANG-based configuration and operational state data store [daemon]
 Applications can use sysrepo to store their configuration modeled by provided
 YANG model instead of using e.g. flat configuration files. Sysrepo will ensure
 data consistency of the data stored in the datastore and enforce data
 constraints defined by YANG model.
 .
 Sysrepo can be easily integrated with management agents such as NETCONF or
 RESTCONF servers, using the same client library API that applications use to
 access their configuration.
 .
 This package contains the daemon for grouping sysrepo plugins.

Package: libsysrepo6t64
Provides: ${t64:Provides}
Replaces: libsysrepo6
Breaks: libsysrepo6 (<< ${source:Version})
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends}
Section: libs
Architecture: any
Multi-Arch: same
Description: YANG-based configuration and operational state data store [C library]
 Applications can use sysrepo to store their configuration modeled by provided
 YANG model instead of using e.g. flat configuration files. Sysrepo will ensure
 data consistency of the data stored in the datastore and enforce data
 constraints defined by YANG model.
 .
 Sysrepo can be easily integrated with management agents such as NETCONF or
 RESTCONF servers, using the same client library API that applications use to
 access their configuration.
 .
 This package contains the shared C library.

Package: libsysrepo-dev
Depends: libsysrepo6t64 (= ${binary:Version}),
         libyang2-dev,
         ${misc:Depends},
         ${shlibs:Depends}
Section: libdevel
Architecture: any
Multi-Arch: same
Description: YANG-based configuration and operational state data store [C development]
 Applications can use sysrepo to store their configuration modeled by provided
 YANG model instead of using e.g. flat configuration files. Sysrepo will ensure
 data consistency of the data stored in the datastore and enforce data
 constraints defined by YANG model.
 .
 Sysrepo can be easily integrated with management agents such as NETCONF or
 RESTCONF servers, using the same client library API that applications use to
 access their configuration.
 .
 This package contains the static C library and headers.
