=== debian/changelog ===
sysrepo (3.6.11-1) unstable; urgency=medium

  * New upstream version (Closes: #976375, #1065080)
  * Install upstream systemd service (Closes: #996847)
  * Update debhelper-compat to 13
  * Install /etc/sysrepo files with umask 002 (Closes: #1037068)

 -- Bastian Germann <bage@debian.org>  Fri, 16 May 2025 17:45:07 +0200
