=== debian/control ===
--- 
+++ 
@@ -1,19 +1,24 @@
 Source: sysrepo
 Section: libs
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Ondřej Surý <ondrej@debian.org>
+Maintainer: Bastian Germann <bage@debian.org>
 Priority: optional
-Standards-Version: 4.5.1.0
-Build-Depends: dpkg-dev (>= 1.22.5), cmake,
-               debhelper-compat (= 12),
-               doxygen,
-               graphviz,
-               libyang2-dev,
-               pkg-config
+Standards-Version: 4.7.2
+Build-Depends:
+ cmake,
+ debhelper-compat (= 13),
+ libyang-dev,
+ pkgconf,
+Build-Depends-Indep:
+ doxygen <!nodoc>,
+ graphviz <!nodoc>,
+Build-Depends-Arch:
+ libcmocka-dev <!nocheck>,
+ libsystemd-dev,
+ systemd-dev,
 Homepage: https://github.com/sysrepo/sysrepo
 
 Package: sysrepo
-Depends: libsysrepo6t64 (= ${binary:Version}),
+Depends: libsysrepo7 (= ${binary:Version}),
          ${misc:Depends},
          ${shlibs:Depends}
 Section: admin
@@ -36,6 +41,7 @@
 Section: doc
 Architecture: all
 Multi-Arch: foreign
+Build-Profiles: <!nodoc>
 Description: YANG-based configuration and operational state data store [docs]
  Applications can use sysrepo to store their configuration modeled by provided
  YANG model instead of using e.g. flat configuration files. Sysrepo will ensure
@@ -49,7 +55,7 @@
  This package contains the documentation.
 
 Package: sysrepo-plugind
-Depends: libsysrepo6t64 (= ${binary:Version}),
+Depends: libsysrepo7 (= ${binary:Version}),
          ${misc:Depends},
          ${shlibs:Depends}
 Section: admin
@@ -67,14 +73,27 @@
  .
  This package contains the daemon for grouping sysrepo plugins.
 
-Package: libsysrepo6t64
-Provides: ${t64:Provides}
-Replaces: libsysrepo6
-Breaks: libsysrepo6 (<< ${source:Version})
+Package: sysrepo-modules
+Depends: ${misc:Depends}
+Architecture: all
+Multi-Arch: foreign
+Description: YANG-based configuration and operational state data store [YANG modules]
+ Applications can use sysrepo to store their configuration modeled by provided
+ YANG model instead of using e.g. flat configuration files. Sysrepo will ensure
+ data consistency of the data stored in the datastore and enforce data
+ constraints defined by YANG model.
+ .
+ Sysrepo can be easily integrated with management agents such as NETCONF or
+ RESTCONF servers, using the same client library API that applications use to
+ access their configuration.
+ .
+ This package contains several YANG modules.
+
+Package: libsysrepo7
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends},
-         ${shlibs:Depends}
-Section: libs
+         ${shlibs:Depends},
+         sysrepo-modules
 Architecture: any
 Multi-Arch: same
 Description: YANG-based configuration and operational state data store [C library]
@@ -90,10 +109,9 @@
  This package contains the shared C library.
 
 Package: libsysrepo-dev
-Depends: libsysrepo6t64 (= ${binary:Version}),
-         libyang2-dev,
+Depends: libsysrepo7 (= ${binary:Version}),
+         libyang-dev,
          ${misc:Depends},
-         ${shlibs:Depends}
 Section: libdevel
 Architecture: any
 Multi-Arch: same
@@ -107,4 +125,4 @@
  RESTCONF servers, using the same client library API that applications use to
  access their configuration.
  .
- This package contains the static C library and headers.
+ This package contains the C headers.
