## sysrepo 3.7.11

=== CMakeLists.txt ===
--- 
+++ 
@@ -53,7 +53,7 @@
 # minor version changes with added functionality (new tool, functionality of the tool or library, ...) and
 # micro version is changed with a set of small changes or bugfixes anywhere in the project.
 set(SYSREPO_MAJOR_VERSION 3)
-set(SYSREPO_MINOR_VERSION 6)
+set(SYSREPO_MINOR_VERSION 7)
 set(SYSREPO_MICRO_VERSION 11)
 set(SYSREPO_VERSION ${SYSREPO_MAJOR_VERSION}.${SYSREPO_MINOR_VERSION}.${SYSREPO_MICRO_VERSION})
 
@@ -61,14 +61,14 @@
 # Major version is changed with every backward non-compatible API/ABI change, minor version changes
 # with backward compatible change and micro version is connected with any internal change of the library.
 set(SYSREPO_MAJOR_SOVERSION 7)
-set(SYSREPO_MINOR_SOVERSION 33)
-set(SYSREPO_MICRO_SOVERSION 5)
+set(SYSREPO_MINOR_SOVERSION 34)
+set(SYSREPO_MICRO_SOVERSION 6)
 set(SYSREPO_SOVERSION_FULL ${SYSREPO_MAJOR_SOVERSION}.${SYSREPO_MINOR_SOVERSION}.${SYSREPO_MICRO_SOVERSION})
 set(SYSREPO_SOVERSION ${SYSREPO_MAJOR_SOVERSION})
 
 # Version of libyang library that this sysrepo depends on
-set(LIBYANG_DEP_VERSION 3.12.0)
-set(LIBYANG_DEP_SOVERSION 3.9.0)
+set(LIBYANG_DEP_VERSION 3.13.2)
+set(LIBYANG_DEP_SOVERSION 3.9.11)
 set(LIBYANG_DEP_SOVERSION_MAJOR 3)
 
 # generate only version header, it is needed for docs
