=== debian/changelog ===
sysrepo (3.7.11-1) unstable; urgency=medium

  * Allow backports
  * New upstream version 3.7.11

 -- Bastian Germann <bage@debian.org>  Mon, 20 Oct 2025 11:32:13 +0200
