=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
 Build-Depends-Arch:
  libcmocka-dev <!nocheck>,
  libsystemd-dev,
- systemd-dev,
+ systemd-dev | systemd (<< 253-2~),
 Homepage: https://github.com/sysrepo/sysrepo
 
 Package: sysrepo
