=== debian/watch ===
version=4
https://github.com/sysrepo/sysrepo/tags \
    (?:.*?/)?v(\d[\d.]+)\.tar\.gz debian
